package controleurs;

import info1.ships.NavyFleet;
import info1.ships.Ship;
import vue.Fenetre;
//import vue.FenetrePlateau;

import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

public class ControleurListeAjoutBateau implements ItemListener {

    private Fenetre fenetre;
    private NavyFleet fleet;


    public ControleurListeAjoutBateau(Fenetre fen, NavyFleet flt){
        this.fenetre = fen;
        this.fleet = flt;
    }

    //Initialise la JComboBox de bateaux à placer dispos en fonction de la config française ou belge
    @Override
    public void itemStateChanged(ItemEvent e) {
        if(fenetre.getChoixModeDeJeu().equals("Français")){
            fenetre.initBateauxEnFonctionModeJeu(fleet.listeShipConfigFrance());
            fenetre.repaint();
        }
        else{
            fenetre.initBateauxEnFonctionModeJeu(fleet.listeShipConfigBelge());
        }
    }
}
