package controleurs;

import com.mashape.unirest.http.exceptions.UnirestException;
import vue.Fenetre;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class ControleurRefresh implements ActionListener {

    /*
    Cette classe a pour but de réaliser l'action d'un refresh de liste des connexions possible
    */

    private Fenetre feneDebut;

    public ControleurRefresh(Fenetre fenetre){
        this.feneDebut = fenetre;
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        try {
            feneDebut.setListePartie(feneDebut.chargerConnexion(feneDebut.getNouvellesParties()));
            feneDebut.repaint();
            System.out.println("Refresh effectué");
        } catch (UnirestException unirestException) {
            unirestException.printStackTrace();
        }
    }
}
