package info1.ships;


import java.util.Objects;

/**
 * une implementation de l'interface ICoord manipulant des coordonnées alphanumériques comme "A1", "B6", "J3", etc.
 */

public class Coord implements ICoord {
    // TODO
    private char x; // x est une lettre en majuscule (de A à J compris)
    private int y; // y ne peut contenir un entier entre 1 et 10 compris

    /**
     * NB : LA SIGNATURE DU CONSTRUCTEUR DOIT ETRE RESPECTEE
     *
     * constructeur d'un objet Coord
     * @param xy la coordonnée aphanumérique sous la forme d'une chaine de caractères
     * @throws BadCoordException si la chaine de caractère ne permet pas de définir une coordonnée alphanumérique
     */
    public Coord(String xy) throws BadCoordException {
        // TODO
        if(xy.length() == 3 || xy.length() == 2){ // vérifie que la taille de la chaine de caratère est de soit 3 soit 2
            // vérifications de x et attributons de x :
            char x = xy.charAt(0);
            if(this.xEstBon(x)){
                this.x = x;
            }else{
                throw new BadCoordException();
            }

            // vérifications de y et attributons de y :
            String y = xy.substring(1);
            if(this.yEstBon(y)){
                this.y = Integer.parseInt(y);
            }else{
                throw new BadCoordException();
            }
        }else{
            throw new BadCoordException();
        }
    }

    @Override
    public char getAlphaX() { // renvoie x en char
        // TODO
        return this.x;
    }

    @Override
    public int getX() { // renvoie x en int
        // TODO
        if(this.x == 'A'){
            return 1;
        }
        if(this.x == 'B'){
            return 2;
        }
        if(this.x == 'C'){
            return 3;
        }
        if(this.x == 'D'){
            return 4;
        }
        if(this.x == 'E'){
            return 5;
        }
        if(this.x == 'F'){
            return 6;
        }
        if(this.x == 'G'){
            return 7;
        }
        if(this.x == 'H'){
            return 8;
        }
        if(this.x == 'I'){
            return 9;
        }
        if(this.x == 'J'){
            return 10;
        }
        System.out.println("erreur");
        return -1;
    }

    @Override
    public int getY() { // renvoie y en int
        return this.y;
    }

    @Override
    public String toString() {
        String res = Character.toString(this.x);
        String y = String.valueOf(this.getY());
        res = res + y;
        return res;
    }

    @Override
    public boolean equals(Object o) { // vérifie l'égaliter entre deux coordonnéer
        if (o == null || this.getClass() != o.getClass()){
            return false;
        }else {
            Coord coord = (Coord) o;
            return (this.x == coord.getAlphaX() && this.y == coord.getY());
        }
    }

    @Override
    public int hashCode() {
        return Objects.hash(x, y);
    }

    public boolean xEstBon(char a){ // vérification que x est autoriser
        boolean res = false;
        if(a == 'A'){
            res = true;
        }
        if(a == 'B'){
            res = true;
        }
        if(a == 'C'){
            res = true;
        }
        if(a == 'D'){
            res = true;
        }
        if(a == 'E'){
            res = true;
        }
        if(a == 'F'){
            res = true;
        }
        if(a == 'G'){
            res = true;
        }
        if(a == 'H'){
            res = true;
        }
        if(a == 'I'){
            res = true;
        }
        if(a == 'J'){
            res = true;
        }
        return res;
    }
    public boolean yEstBon(String a){ // vérification que y est autoriser
        boolean res = false;
        if(a.equals("10")){
            res = true;
        }
        if(a.equals("9")){
            res = true;
        }
        if(a.equals("8")){
            res = true;
        }
        if(a.equals("7")){
            res = true;
        }
        if(a.equals("6")){
            res = true;
        }
        if(a.equals("5")){
            res = true;
        }
        if(a.equals("4")){
            res = true;
        }
        if(a.equals("3")){
            res = true;
        }
        if(a.equals("2")){
            res = true;
        }
        if(a.equals("1")){
            res = true;
        }
        return res;
    }


}