/*
#################################
##                             ##
##      Lire le README !!      ##
##                             ##
#################################
*/

import controleurs.*;
import info1.ships.*;
import vue.Fenetre;
import vue.Plateau;

public class Appli {

    /**
     * méthode principale éxécutable
     *
     * @param args
     *
     */
    public static void main(String[] args) throws Exception {

        ///--------Initialisation----------
        NavyFleet navyFleet = new NavyFleet();

        //-----------------On crée la vue-----------------------
        Plateau plateauPers = new Plateau();
        Fenetre placerBateau = new Fenetre(plateauPers);

        //----------Ajout des listener-----------------
        placerBateau.FixedListenerCommencerUnPartie(new StartPartie(placerBateau,navyFleet));                       //Listener qui fais créer une partie
        placerBateau.FixedListenerRejoindreUnePartie(new RejoindrePartie(placerBateau,navyFleet));                            //Listener qui fais rejoindre une partie
        placerBateau.fixeListenerAjoutBateau(new ControleurPlacerBateauSelectionne(placerBateau,navyFleet));        //Listener ajouter placement bateau
        placerBateau.fixeListenerRemplissageCategorie(new ControleurListeAjoutBateau(placerBateau, navyFleet));     //Ajouter bateaux en fonction du mode de jeu
        placerBateau.fixedListenerChargerPartie(new ControleurRefresh(placerBateau));//Rafraichir la liste des connexions
        placerBateau.fixeListenerRepaintOnComboBox(new ControleurRepaint(placerBateau), new ControleurRepaint(placerBateau), new ControleurRepaint(placerBateau));
    }

}

