package controleurs;

import info1.ships.NavyFleet;
import vue.Fenetre;
import vue.FenetrePlateau;
import vue.Plateau;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class ControleurBoutonQuitter implements ActionListener {

    private FenetrePlateau fenetrePlateau;

    public ControleurBoutonQuitter(FenetrePlateau fen){
        this.fenetrePlateau = fen;
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        fenetrePlateau.dispose();
        Plateau plateauPers = new Plateau();
        Fenetre placerBateau = null;
        try {
            placerBateau = new Fenetre(plateauPers);
        } catch (Exception exception) {
            exception.printStackTrace();
        }
        NavyFleet navyFleet = new NavyFleet();

        placerBateau.FixedListenerCommencerUnPartie(new StartPartie(placerBateau,navyFleet));
        placerBateau.FixedListenerRejoindreUnePartie(new RejoindrePartie(placerBateau,navyFleet));
        placerBateau.fixeListenerAjoutBateau(new ControleurPlacerBateauSelectionne(placerBateau,navyFleet)); //Listener ajouter placement bateau
        placerBateau.fixeListenerRemplissageCategorie(new ControleurListeAjoutBateau(placerBateau, navyFleet)); //Ajouter bateaux en fonction du mode de jeu
        placerBateau.pack();
        placerBateau.setVisible(true);


    }
}
