package controleurs;

import vue.FenetrePlateau;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class ControleurBoutonRegle implements ActionListener {

    private FenetrePlateau fenetrePlateau;

    public ControleurBoutonRegle(FenetrePlateau fen){
        this.fenetrePlateau = fen;
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        JFrame erreur = new JFrame();
        String message = "Ce jeu est simple !\n" +
                         "Votre écran est à gauche, il affiche la disposition que vous avez choisi pour vos bateaux au menu précédent.\n" +
                         "A droite se trouve la disposition de votre adversaire, cachée évidemment ; chacun votre tour, vous allez tenter de couler\n" +
                         "les bateaux ennemis. Il faut cliquer sur une case pour tirer ; si la case est vide, elle reste grisée. A l'inverse, si vous touchez \n" +
                         "un bateau ennemi, la case restera marquée en rouge. Lorsqu'un bateau est coulé, la dernière case touchée s'affichera en bleu foncé !\n" +
                         "Le gagnant sera le premier joueur qui réussira à couler tous les navires adverses !";
        JOptionPane.showMessageDialog(erreur, message, "Règles du jeu", JOptionPane.INFORMATION_MESSAGE);
    }
}
