/*
#################################
##                             ##
##      Lire le README !!      ##
##                             ##
#################################
*/

package vue;

import javax.swing.*;
import java.awt.*;

public class Case extends JPanel{

    private int coordX;
    private int coordY;

    //Le constructeur de Case permet de lui donner des coordonnées X et Y
    //Cela nous permet de savoir ensuite à quel position du plateau elle est placée lors du tir sur l'adversaire
    public Case(int x, int y){
        this.coordX = x;
        this.coordY = y;

        //AJout d'une couleur de fond et d'une bordure pour délimiter la case
        this.setBackground(new Color(6,66,115));
        this.setBorder(BorderFactory.createMatteBorder(1, 1, 1, 1, Color.lightGray));

    }

    //Méthode qui permet de retourner les coordonnées d'une case dans la console
    public String toString(){
        return "X : "+ this.getCoordX() + " Y : " + this.getCoordY();
    }

    //Les getters renvoient l'inverse pour mieux coller au modèle
    //A corriger si le temps, c'est pour être raccord avec la classe Coords
    public int getCoordX() {
        return coordY;
    }

    public int getCoordY() {
        return coordX;
    }

    //Permet de changer la couleur d'une case depuis l'extérieur de la classe
    public void setColor(Color couleur){
        this.setBackground(couleur);
    }

}
