/*
#################################
##                             ##
##      Lire le README !!      ##
##                             ##
#################################
*/

package vue;
import javax.swing.*;
import java.awt.*;


public class CaseBouton extends JButton {

    private int coordX;
    private int coordY;


    //Elle reprend le fonctionnement de Case mais hérite de JButton et non de JPanel
    //Ce sont les cases cliquables (celles de l'adversaire)
    public CaseBouton(int x, int y) {
        this.coordX = x;
        this.coordY = y;

        this.setBackground(new Color(6, 66, 115));
        this.setBorder(BorderFactory.createMatteBorder(1, 1, 1, 1, Color.lightGray));

    }

    public String toString(){
        return "X : "+ this.getCoordX() + " Y : " + this.getCoordY();
    }


    //Les getters renvoient l'inverse pour mieux coller au modèle
    //A corriger si le temps, c'est pour être raccord avec la classe Coords
    public int getCoordX() {
        return coordY;
    }

    public int getCoordY() {
        return coordX;
    }

    public void setColor(Color couleur){
        this.setBackground(couleur);
    }



}
